<template>
	<div
		class="modal fade"
		id="formModal"
		tabindex="-1"
		aria-labelledby="formModalLabel"
		aria-hidden="true"
	>
		<div class="modal-dialog modal-md modal-dialog-centered">
			<!-- <div class="modal-dialog modal-xl"> --><!-- Pantalla completa -->
			<div class="modal-content" style="background-color: aliceblue">
				<div class="modal-header">
					<h5 class="modal-title h4" id="formModalLabel">
						{{ dialog.title }}
					</h5>
					<button
						type="button"
						class="btn-close"
						data-bs-dismiss="modal"
						aria-label="Close"
					></button>
				</div>
				<div class="modal-body">
					<div class="container-fluid">
						<div class="row">
							<div class="col-8">
								<label for="doc_escan_tipo" class="form-label"
									>Tipo de documento</label
								>
								<select
									id="doc_escan_tipo"
									class="form-select form-select-sm"
									aria-label="Tipo de documento"
									v-model="form.doc_escan_tipo"
								>
									<option
										v-for="t in globales.docs_escan_tipos"
										:value="t"
										:key="t.id_tipo_doc_escan"
									>
										{{ t.d_tipo_doc_escan }}
									</option>
								</select>
							</div>
							<div class="col-4">
								<button
									type="button"
									class="btn btn-primary mt-4"
									@click="validarDocEscanTipo()"
								>
									Escanear
								</button>
							</div>
							<saveDocEscan
								ref="saveDocEscan"
								:titulo="titulo"
								:doc_escan_tipo="form.doc_escan_tipo"
							/>
						</div>
					</div>
				</div>
				<div class="modal-footer">
					<button
						type="button"
						class="btn btn-secondary"
						data-bs-dismiss="modal"
					>
						Cerrar
					</button>
				</div>
			</div>
			<!-- </div> -->
		</div>
	</div>
</template>

<script lang="ts" type="module">
import { defineComponent } from "vue";
import type { AxiosResponse } from "axios";
// import type  Modal as ModalType  from "bootstrap/js/dist/modal.js";
import Modal  from "bootstrap/js/dist/modal.js";
import { Titulo } from "@/entities/Titulo";
import http from "@/http";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions } from "sweetalert2";
//import { mapStores } from "pinia";
//import { useTitulosStore } from "@/stores/titulos";
import type { DocEscanTipo as DocEscanTipoType } from "@/entities/DocEscanTipo";
import { DocEscanTipo } from "@/entities/DocEscanTipo";
import { saveDocEscan } from "./SaveDocEscan";
import shared from "@/shared.js";

const { urlApiEscan } = shared();

export default defineComponent({
	name: "FormDocsEscanTipos",
	components: {
		saveDocEscan,
	},
	props: {
		titulo: {
			type: Titulo,
			required: false,
			default: undefined,
		},
	},
	data() {
		return {
			dialog: {
				modal: null as ModalType | null,
				title: "Escaneo de documentación" as String,
			},
			form: {
				doc_escan_tipo: undefined as DocEscanTipoType | undefined,
			},
			globales: {
				docs_escan_tipos: [] as DocEscanTipoType[],
			},
		};
	},
	mounted() {
		this.dialog.modal = new Modal("#formModal", {
			show: false,
		});
		//http.defaults.baseURL = "http://localhost/admin/escaner";
		if (this.globales.docs_escan_tipos.length === 0) {
			this.getDocsEscanTipos();
		}
	},
	methods: {
		async getDocsEscanTipos() {
			const doc_escan_tipo = new DocEscanTipo();
			const swal = {
				icon: "error",
				title: "Error",
				html: "",
			} as SweetAlertOptions;
			this.globales.docs_escan_tipos.push(doc_escan_tipo);
			try {
				const rta: AxiosResponse<DocEscanTipo[]> = await http.request<
					DocEscanTipo[]
				>({
					method: "GET",
					url: urlApiEscan + "buscarDocsEscanTiposExc",
					//data: formData,
					transformResponse: [
						(data: string) => {
							const doc_escan_tipos: DocEscanTipo[] = JSON.parse(data);
							const dataAux: DocEscanTipo[] = [];
							doc_escan_tipos.forEach((element: DocEscanTipo) => {
								dataAux.push(Object.assign(new DocEscanTipo(), element));
							});
							return dataAux;
						},
					],
				});
				this.globales.docs_escan_tipos = this.globales.docs_escan_tipos.concat(
					rta.data
				);
			} catch (error: unknown) {
				if (error.response) {
					// Request made and server responded
					swal.html =
						error.message +
						" (" +
						error.code +
						")." +
						"<br />" +
						error.response.data.substring(
							error.response.data.indexOf("<h2>") + 4,
							error.response.data.indexOf("</h2>")
						);
					console.log("Error: request made and server responded");
					console.log(swal.html);
					console.log(error.response);
					//console.log(error.response.status);
					//console.log(error.response.headers);
					//console.log(error.response.data);
				} else if (error.request) {
					// The request was made but no response was received
					swal.html = "Error desconocido. Por favor, avise al Administrador.";
					console.log(
						"Error: the request was made but no response was received"
					);
					console.log(error.request);
				} else {
					// Something happened in setting up the request that triggered an Error
					swal.html = "Error desconocido. Por favor, avise al Administrador.";
					console.log(
						"Error: something happened in setting up the request that triggered an error"
					);
					console.log(error);
				}
				Swal.fire(swal);
			}
		},
		clear() {
			this.form.doc_escan_tipo =
				this.globales.docs_escan_tipos.length > 0
					? this.globales.docs_escan_tipos[0]
					: undefined;
		},
		show() {
			this.clear();
			this.dialog.modal.show();
		},
		hide() {
			this.dialog.modal.hide();
		},
		validarDocEscanTipo() {
			const swal = {
				icon: "error",
				title: "Error",
				html: "",
			} as SweetAlertOptions;
			if (
				this.form.doc_escan_tipo === undefined ||
				this.form.doc_escan_tipo.id_tipo_doc_escan === undefined
			) {
				swal.html = "Por favor, seleccione un tipo de documento v&aacute;lido.";
				Swal.fire(swal);
				return;
			}
			this.generarDocEscan();
		},
		generarDocEscan() {
			this.hide();
			this.$refs.saveDocEscan.generarDocEscan();
		},
	},
	watch: {},
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
